#include "common.h"
#include "adc.h"



uint16_t adcGet(uint8_t channel)
{
	//define configuration fields in ADC_MR register
	const uint32_t SHTIM_MASK = 0x00 << 24;   //sample and hold time
	const uint32_t STARTUP_MASK = 0x04 << 16; //startup time
	const uint32_t PRESCAL_MASK = 0x4 << 8;   //prescaler setting
	
	//configure ADC
	AT91C_BASE_ADC->ADC_MR = SHTIM_MASK | STARTUP_MASK | PRESCAL_MASK | AT91C_ADC_TRGEN_EN;
	
	//activate requested channel
    channel = channel & 0x07;
    AT91C_BASE_ADC->ADC_CHER =	1<<channel;
	
	//start conversion!
	AT91C_BASE_ADC->ADC_CR = AT91C_ADC_START;
	
	//wait for adc DRDY bit set
	while( ! (AT91C_BASE_ADC->ADC_SR & AT91C_ADC_DRDY) );
	
	//read result from LCDR register
	uint16_t retval = AT91C_BASE_ADC->ADC_LCDR;
	
	//disable all channels
	AT91C_BASE_ADC->ADC_CHDR =	0xFF;
	
	return(retval);
}





