



const char USB_DeviceDescriptor[] = {
	/* Device descriptor */
	0x12,   // bLength
	0x01,   // bDescriptorType
	0x00,   // bcdUSBL
	0x02,   //
	0x00,   // bDeviceClass
	0x00,   // bDeviceSubclass
	0x00,   // bDeviceProtocol
	0x08,   // bMaxPacketSize0
	0xCD,   // idVendorL (EB)
	0xAB,   //          (03)
	0x01,   // idProductL (24)
	0xEF,   //            (61)
	0x00,   // bcdDeviceL
	0x01,   //
	0x01,   // iManufacturer
	0x02,   // iProduct
	0x03,   // SerialNumber
	0x01    // bNumConfigs
};



//cfgDEscriptor + interfaceDescriptor + bulkInEndpointDescriptor + bulkOutEndpointDescriptor
const char USB_ConfigDescriptor[] =
{
    0x09,   //size of this description
    0x02,   //bDescriptorType: config decriptor type
    0x20,   //wTotalLength (L)
    0x00,   //wTotalLength (H)
    0x01,   //bNumInterfaces
    0x01,   //bConfigurationValue
    0x00,   //iConfiguration: index of config string
    0xC0,   //bmAttributes: Configuration characteristics - bit7-reserved, bit6-self powered
    0x00,    //MaxPower [*2mA]

//interface descriptor
    0x09,   //bLength: size of this descriptor
    0x04,   //bDescriptorType
    0x00,   //bInterfaceNumber
    0x00,   //bAlternateSetting
    0x02,   //bNumEndpoints: Number of endpoints excluding endpoint 0
    0x08,   //bInterfaceClass: Here 0x08 Mass Storage Class
    0x06,   //bInterfaceSubClass: Here: SCSI Transparent Command Set
    0x50,   //bInterfaceProtocol: Here: BULK-ONLY TRANSPORT
    0x00,   //iInterface: Index to string descriptor of this interface

//BULK-IN Endpoint descriptor (EP1)
// ( DEVICE -> HOST )
    0x07,   //bLength: size of this descriptor
    0x05,   //bDescriptorType: Here: Endpoint descriptor type
    0x81,   //Endpoint 1, direction IN
    0x02,   //bmAttributes: This is a Bulk Endpoint
    0x40,   //wMaxPacketSize: Here it is 64
    0x00,   //wMaxPAcketSize higher byte
    0x00,    //bInterval: does not apply to bulk endpoints
    
//BULK-OUT Endpoint descriptor (EP2)
// ( HOST -> DEVICE )
    0x07,   //bLength: size of this descriptor
    0x05,   //bDescriptorType: Here: Endpoint descriptor type
    0x02,   //bEndpointAddress: Here EP2
    0x02,   //bmAttributes: This is a Bulk Endpoint
    0x40,   //wMaxPacketSize: Here it's 64
    0x00,   //wMaxPAcketSize higher byte
    0x00,   //bInterval: does not apply to bulk endpoints

};




const uint8_t USB_LanguageStringDescriptor[] = {
    // Language descriptor
    0x04,    // bLength
    0x03,    // bDescriptorType: string descriptor
    0x09,    // Supported language: English - United States
    0x04,
};

const uint16_t USB_ManufacturerStringDescriptor[] = {
    // Manufacturer descriptor
    0x0306,    // bLength, bDescriptorType: string descriptor
    'K', 
    'Q', 
};

const uint16_t USB_ProductStringDescriptor[] = {
    // Product descriptor
    0x0326,    // bLength, bDescriptorType: string descriptor
    'x', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
    ' ', 
};

const uint16_t USB_SerialNumberStringDescriptor[] = {
    // Serial descriptor
    0x0326,    // bLength, bDescriptorType: string descriptor
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
    '0', 
};




