#include "common.h"
#include "one_wire.h"
#include "ds18b20.h"



//function commands
#define ONE_WIRE_CMD_CONVERT_T          0x44
#define ONE_WIRE_CMD_READ_SCRATCHPAD    0xBE
#define ONE_WIRE_CMD_WRITE_SCRATCHPAD   0x4E
#define ONE_WIRE_CMD_COPY_SCRATCHPAD    0x48



void ds18b20ConvertT(void)
{
	if(owPresence()==OK)
	{
		owWrite(ONE_WIRE_CMD_SKIP_ROM);
		owWrite(ONE_WIRE_CMD_CONVERT_T);
		owStrongPullupOn();
	}
}






int16_t ds18b20ReadTempNoRom(void)
{
	owStrongPullupOff();
	if(owPresence())
	{
		owWrite(ONE_WIRE_CMD_SKIP_ROM);
		owWrite(ONE_WIRE_CMD_READ_SCRATCHPAD);
		uint8_t tempL;
		uint8_t tempH;
		tempL = owRead();
		tempH = owRead();
		owPresence();
		int16_t temperature = ( (uint16_t)tempH << 8) | tempL;
		return(temperature);
	}
	return(0x7FFF);
}

