//*----------------------------------------------------------------------------
//*      ATMEL Microcontroller Software Support  -  ROUSSET  -
//*----------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*----------------------------------------------------------------------------
//* File Name           : cdc_enumerate.h
//* Object              : Handle CDC enumeration
//*
//* 1.0 Apr 20 200 	: ODi Creation
//* July 3 2008, RABW: simplified and modified to fit AT91SAM7XC128/256 eval kit
//*----------------------------------------------------------------------------
#ifndef CDC_ENUMERATE_H
#define CDC_ENUMERATE_H

typedef struct __attribute__((packed))
{
	unsigned int dwDTERRate;
	char bCharFormat;
	char bParityType;
	char bDataBits;
} AT91S_CDC_LINE_CODING, *AT91PS_CDC_LINE_CODING;


#define AT91C_EP_OUT 1
#define AT91C_EP_OUT_SIZE 0x40
#define AT91C_EP_IN  2

void AT91F_CDC_Open(void);
uint32_t AT91F_UDP_Write(const uint8_t *pData, uint32_t length);
uint32_t AT91F_UDP_Read(uint8_t *pData);
uint8_t cdcGetLineCoding(AT91PS_CDC_LINE_CODING lineCoding);

#endif // CDC_ENUMERATE_H

