#include "common.h"
#include "dbgu.h"
#include "cdc_enumerate.h"



void init(void)
{
	// enable peripheral clock for PIO controllers
	AT91C_BASE_PMC->PMC_PCER = (1<<AT91C_ID_PIOA);
	AT91C_BASE_PMC->PMC_PCER = (1<<AT91C_ID_PIOB);
	
	// enable reset-key on board 
	AT91C_BASE_RSTC->RSTC_RMR = (0xA5000000 | AT91C_RSTC_URSTEN);
	
	//open debug channel
	debug_init_default();
	
	//initialize LEDs
	LED_R_INIT;
	LED_Y_INIT;
	LED_G_INIT;
	LED_B_INIT;
	
	//initialize USB CDC device
	AT91F_CDC_Open();
}

int main( void )
{
	init();
	
	uint8_t buf[10];

	for(;;)
	{
		
		uint32_t len = AT91F_UDP_Read(buf);
		
		if(len)
		{
			debug_txt_limit(buf,len);
		}
		
		uint8_t key = debug_inkey();
		if(key)
		{
			AT91F_UDP_Write(&key,1);
		}
		
	}
	
	return(0);
}


