#include "common.h"
#include "msc_if.h"


//USB MSC inteface to physical mass storage device. Provides interface functions for logical unit(s).


//user headers
#include "sd_spi.h"
#include "aes.h"


//mscMaxLUN is placed in msc_usb.h
extern volatile uint8_t mscMaxLUN;



//========================================================================================
//									DISK DETECTION
//========================================================================================
//must set values of last lba and sector_size
inline uint8_t mscGetCapacity(uint32_t *lba, uint16_t *sector_size,uint8_t lun)
{
	lun=lun;
	sdGetSizeInfo(lba,sector_size);
	*lba = *lba - 1;
	return(1);
}



//========================================================================================
//									DISK R/W OPERATIONS
//========================================================================================
//must return 1 if read is ok
inline uint8_t mscReadSectors(uint32_t lba, uint8_t sectors, uint8_t *buf,uint8_t lun)
{
	lun=lun;
	sdReadBlocks(lba,sectors,buf);
	aesDecrypt((void*)buf,512*sectors,lba);
	return(1);
}


//must return 1 if write is ok
inline uint8_t mscWriteSectors(uint32_t lba, uint8_t sectors, uint8_t *buf,uint8_t lun)
{
	lun=lun;
	aesEncrypt((void*)buf,512*sectors,lba);
	sdWriteBlocks(lba,sectors,buf);
	return(1);
}

