#ifndef __BOARD_H__
#define __BOARD_H__


#ifdef AT91SAM7S256
    #include "include/at91sam7s256.h"
    #include "include/lib_at91sam7s256.h"
#elif AT91SAM7X256
    #include "include/at91sam7x256.h"
    #undef __inline
    #define __inline static inline
    #include "include/lib_at91sam7x256.h"
#elif AT91SAM7S64
    #include "include/at91sam7s64.h"
    #undef __inline
    #define __inline static inline
    #include "include/lib_at91sam7s64.h"
#elif AT91SAM7XC128
	//use header for SAM7XC
	#include "include/at91sam7xc128.h"
	//use lib_ for SAM7X
    #undef __inline
    #define __inline static inline
    #include "include/lib_at91sam7x128.h"
#elif AT91SAM7XC256
	//use header for SAM7XC
	#include "include/at91sam7xc256.h"
	//use lib_ for SAM7X
    #undef __inline
    #define __inline static inline
    #include "include/lib_at91sam7x256.h"
#else
    #error SUBMDL, no match!
#endif

//standard includes
#include <inttypes.h>

//common includes
#include "delay.h"

//global defs
#define EXT_OC          18432000   // Exetrnal ocilator MAINCK
#define MCK             48054857   // MCK (PLLRC div by 2)

#define OK				1
#define FAIL			0

//LED Red
#define LED_R_PIO		AT91C_BASE_PIOB
#define LED_R_MASK		AT91C_PIO_PB23

//LEDs interface defs -- to be used in the program
#define LED_R_INIT		{LED_R_PIO->PIO_PER = LED_R_MASK; LED_R_PIO->PIO_OER = LED_R_MASK; LED_R_PIO->PIO_OWER = LED_R_MASK;}
#define LED_R_ON		LED_R_PIO->PIO_SODR = LED_R_MASK
#define LED_R_OFF		LED_R_PIO->PIO_CODR = LED_R_MASK
#define LED_R_TOGGLE	LED_R_PIO->PIO_ODSR ^= LED_R_MASK


#endif
