
#ifndef __SD_SPI_H__
#define __SD_SPI_H__

//=================================================================================================
//user-configurable area
//=================================================================================================

    //chip select settings
	#define SD_SPI				AT91C_BASE_SPI0
    #define SD_NPCS_PIO_PIN     12              //pin number
    #define SD_NPCS_PIO         AT91C_BASE_PIOA //pointer to pio controller
    #define SD_NPCS_PIO_ID      AT91C_ID_PIOA   //periph ID
    #define SD_NPCS_PIO_PERIPH  0               //zero for peripheral A, 1 for peripheral B
    #define SD_NPCS_NUMBER      0               //number of NPCS register (valid 0...3)
    #define SD_NPCS_SELECT      0               //PCSDEC field, direct connection to CS pin of SD card
	//just LEDz
	#define SD_LED_WR_INIT		{AT91C_BASE_PIOA->PIO_PER = AT91C_PIO_PA4; AT91C_BASE_PIOA->PIO_OER = AT91C_PIO_PA4; AT91C_BASE_PIOA->PIO_CODR = AT91C_PIO_PA4;}
	#define SD_LED_RD_INIT		{AT91C_BASE_PIOA->PIO_PER = AT91C_PIO_PA2; AT91C_BASE_PIOA->PIO_OER = AT91C_PIO_PA2; AT91C_BASE_PIOA->PIO_CODR = AT91C_PIO_PA2;}
	#define SD_LED_WR_ON		AT91C_BASE_PIOA->PIO_SODR = AT91C_PIO_PA4;
	#define SD_LED_RD_ON		AT91C_BASE_PIOA->PIO_SODR = AT91C_PIO_PA2;
	#define SD_LED_WR_OFF		AT91C_BASE_PIOA->PIO_CODR = AT91C_PIO_PA4;
	#define SD_LED_RD_OFF		AT91C_BASE_PIOA->PIO_CODR = AT91C_PIO_PA2;
	

//=================================================================================================

#define SD_NPCS_PIN_MASK    (1<<SD_NPCS_PIO_PIN)

#define SPI_SCBR_MIN        2

#define	CMDREAD		17
#define	CMDWRITE	24
#define	CMDREADCSD   9



uint8_t sdCardInit(void);
uint8_t sdSPIInit(void);
inline void AT91F_PIO_SelectPeripheral(AT91PS_PIO pPio, uint32_t Mask, uint8_t PeriphSelect);
void sdSPISetSpeed(uint8_t speed);
uint8_t sdResponse8_t(void);
uint16_t sdResponse16_t(void);
uint8_t sdSPIDataTransfer(uint8_t dat);
uint8_t sdCommand(uint8_t cmd, uint16_t paramx, uint16_t paramy);
uint8_t sdGetSizeInfo(uint32_t *NumberOfBlocks, uint16_t *BlockSize);
uint8_t sdReadBlock(uint32_t BlockAddress, uint8_t *Buffer);
uint8_t sdWriteBlock(uint32_t BlockAddress, uint8_t *Buffer);
uint8_t sdReadBlocks(uint32_t LBA, uint8_t blocks, uint8_t *buf);	//just a wrapper to sdReadBlock
uint8_t sdWriteBlocks(uint32_t LBA, uint8_t blocks, uint8_t *buf);	//just a wrapper to sdWriteBlock


#endif



