

#include "board.h"
#include "common.h"
#include "dbgu.h"
#include "spi.h"


void spiInit(void)
{
    //set PIO pins to be controlled by SPI
    SPI_PIO->PIO_PDR = SPI_PINS_MASK;
    #if SPI_PIO_PERIPH == 0
        SPI_PIO->PIO_ASR = SPI_PINS_MASK;
    #else
        SPI_PIO->PIO_BSR = SPI_PINS_MASK;
    #endif
    
    //enable SPI clock
    AT91C_BASE_PMC->PMC_PCER = ( 1 << SPI_ID );
	
    //spi enable and reset
    SPI->SPI_CR = AT91C_SPI_SPIEN | AT91C_SPI_SWRST;
	
    //SPI Mode Register: Fault detection disable, variable periph. chip select
    SPI->SPI_MR  = AT91C_SPI_MSTR | AT91C_SPI_MODFDIS | AT91C_SPI_PS;
	
    //enable SPI
    SPI->SPI_CR = AT91C_SPI_SPIEN;	//check this!
    
}


